#define $VERSION "0.18"
#define WRITE_SYSLOG 1	/* store new metar lines in /var/log/messages */

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>


/* get metar data section */
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <getopt.h>
#include <syslog.h>

#include <time.h>
#include <sys/time.h>

#include <pwd.h>
#include <sys/types.h>

#define CONFIG_FILE	".kde/share/config/kwthrc"
//char* config_file ="~/.kde/share/config/kwthrc";
char config_file[256] = {"~/.kde/share/config/kwthrc"};

char	confMetar[8] = {"MAPA"};
int	confFrequency = 0;

int writeConfig( void);



int readConfig( void)
{
FILE*	f = NULL;
char	buf[64];
char	*val;
char	temp[16];
int		i;

	f = fopen(config_file, "r");

	if (!f)
	{
		printf("Read error: %s: %d (%s).\n",
			config_file, errno, strerror(errno));
		return (writeConfig());
	}
	else
	{
		while (fgets (buf, sizeof(buf)-1, f))
		{
			if ((val = strchr(buf,'='))!=NULL)
			{
				*val = 0;
				val++;

				if (strncmp (buf, "metar", 5) == 0)
				{
					i = sscanf(val, "%s", temp);
					if(i == 1)
						strncpy(confMetar, temp, 4);
				}
				else if (strncmp (buf, "frequency", 9) == 0)
				{
					i = atoi (val);
					if ((i > 0) && (i < 600))
						confFrequency = i;
				}
			}
		}
		fclose (f);
	}
	return 0;
}


int writeConfig( void)
{
FILE*	f = NULL;
char	buf[64];

	f = fopen(config_file, "w");
	if (!f)
	{
		printf("Write error: %s: %d (%s).\n",
			config_file, errno, strerror(errno));
		return 1;
	}
	sprintf (buf,"[ kwth "$VERSION" config file ]\n\n");
	fputs(buf, f);

	sprintf (buf,"metar = %s\n", confMetar);
	fputs(buf, f);

	sprintf (buf,"frequency = %d\n", confFrequency);
	fputs(buf, f);

	fclose(f);

	return 0;
}


int main()
{
int i;
struct passwd	*userdata;

userdata = getpwuid(getuid());
sprintf(config_file,"%s/%s",userdata->pw_dir,CONFIG_FILE);

i = readConfig();

return (i);
}